<?php
/**
 * Contact Form Options
 *
 * @package Weddi_Pro
 */

class Weddi_Pro_Contact_Form_Options {
	public function __construct() {
		// Register Contact Form Options.
		add_action( 'customize_register', array( $this, 'register_options' ), 99 );

		// Add default options.
		add_filter( 'weddi_pro_customizer_defaults', array( $this, 'add_defaults' ) );
	}

	/**
	 * Add options to defaults
	 */
	public function add_defaults( $default_options ) {
		$defaults = array(
			'weddi_pro_contact_form_visibility' => 'disabled',
		);

		$updated_defaults = wp_parse_args( $defaults, $default_options );

		return $updated_defaults;
	}

	/**
	 * Add layouts section and its controls
	 */
	public function register_options( $wp_customize ) {
		Weddi_Pro_Customizer_Utilities::register_option(
			array(
				'settings'          => 'weddi_pro_contact_form_visibility',
				'type'              => 'select',
				'sanitize_callback' => 'weddi_pro_sanitize_select',
				'label'             => esc_html__( 'Visible On', 'weddi-pro' ),
				'section'           => 'weddi_pro_ss_contact_form',
				'choices'           => Weddi_Pro_Customizer_Utilities::section_visibility(),
			)
		);

		// Add Edit Shortcut Icon.
		$wp_customize->selective_refresh->add_partial( 'weddi_pro_contact_form_visibility', array(
			'selector' => '#contact-form-section',
		) );

		Weddi_Pro_Customizer_Utilities::register_option(
			array(
				'custom_control'    => 'Weddi_Pro_Dropdown_Posts_Custom_Control',
				'sanitize_callback' => 'absint',
				'settings'          => 'weddi_pro_contact_form_page',
				'label'             => esc_html__( 'Select Page', 'weddi-pro' ),
				'section'           => 'weddi_pro_ss_contact_form',
				'active_callback'   => array( $this, 'is_section_visible' ),
				'input_attrs' => array(
					'post_type'      => 'page',
					'posts_per_page' => -1,
					'orderby'        => 'name',
					'order'          => 'ASC',
				),
			)
		);

		Weddi_Pro_Customizer_Utilities::register_option(
			array(
				'type'              => 'text',
				'sanitize_callback' => 'weddi_pro_text_sanitization',
				'settings'          => 'weddi_pro_contact_form_custom_subtitle',
				'label'             => esc_html__( 'Top Subtitle', 'weddi-pro' ),
				'section'           => 'weddi_pro_ss_contact_form',
				'active_callback'   => array( $this, 'is_section_visible' ),
			)
		);
	}

	/**
	 * Contact Form visibility active callback.
	 */
	public function is_section_visible( $control ) {
		return ( weddi_pro_display_section( $control->manager->get_setting( 'weddi_pro_contact_form_visibility' )->value() ) );
	}
}

/**
 * Initialize class
 */
$weddi_pro_ss_contact_form = new Weddi_Pro_Contact_Form_Options();
